Subject: RE: iSCSI: Inquiry, Mode Sense, Read Capacity

From: [email-masked]
Date: Wed, 3 Oct 2001 14:21:04 -0400

The governing text is the following from p.62 of -08 on the contents of
the Response PDU:

     3.4.6 Data Segment - Sense and Response Data Segment 
         
        iSCSI targets MUST support and enable autosense.  If Status is CHECK

        CONDITION (0x02), then the Data Segment contains sense data for the 
        failed command.  
         
        For some iSCSI responses, the response data segment MAY contain some

        response related information, (e.g., for a target failure it may 
        contain a vendor specific detailed description of the failure). 

Julian may be able to shed more light on the intended meaning of
"phase collapse" for the response case, but the above text makes
it quite clear that data transferred by the action of a SCSI command
(including Read, Inquiry, Mode Sense, and Read Capacity) cannot be
put in the Response PDU.  A target can send the Response PDU immediately
following the last Data-In PDU for the associated command, which is
similar to the ability of an Initiator to send unsolicited Data-Out
PDUs.  There is no Target analog to the Initiator's ability to send
Immediate Data in the same PDU as the SCSI command.

Thanks,
--David

> -----Original Message-----
> From: Lee Xing [mailto:[email-masked]]
> Sent: Wednesday, October 03, 2001 2:00 PM
> To: [email-masked]; [email-masked]
> Subject: RE: iSCSI: Inquiry, Mode Sense, Read Capacity
> 
> 
> David,
> 
> Thanks for the info.  It helps.  
> Please see my new question below.
> 
> 
> > Q2:
> > There are 10 target opcodes on page 43 of v.07, and two of 
> > them are specified as:
> > (-snip)
> 
> See previous answer.  Data-in transfers data for any SCSI command
> that has data to transfer.  This includes all three of your examples.
> "READ" actually includes any SCSI command that transfers "data" (as
> that term is defined by SCSI) from Target to Initiator.  This includes
> INQUIRY, MODE SENSE, and READ CAPACITY.
> 
> 
> 
> New Question:
> 
> on page 23 of v.08, it says "For performance reasons, iSCSI allows 
> a "phase-collapse".  A command and its associated data may be 
> shipped together from initiator to target and data and responses 
> may be shipped together from targets."
> 
> The question is if "Data-in transfers data for any SCSI command 
> that has data to transfer" (see the answer to Q2) is a true 
> statement, should we clear the above sentence (on page 23 of v.08) 
> a bit?
> 
> Thanks.
> 
> 
> 
> Lee 
> Crossroads Systems, Inc.
>

---

From: Sandeep Joshi <[email-masked]>
Date: Wed, 03 Oct 2001 15:09:02 -0400

Just a small correction on this topic..
  > There is no Target analog to the Initiator's ability to send

There is an analog, but its part of the Data-IN PDU
See Section 3.7.
  > Status can accompany the last Data-in PDU if the command did not end 
  > with an exception.  Presence of status (and of a residual count) is 
  > signaled though the S flag bit.

-Sandeep